P.when("jQuery", "ready").execute(function($) {
    "use strict";

    var $navBar = $('.dp-primary-nav');
    var $searchForm = $('.dp-navbar-search-form');
    var $searchFormField = $('.dp-navbar-search-field');
    var $searchCloseBtn = $('.dp-navbar-search-close-button');
    var $searchSubmitBtn = $('.dp-navbar-search-button');
    var focusDelay;

    function toggleSearch(e) {
      if(!$searchForm.hasClass('dp-navbar-search-form--isActive')) {
        e.preventDefault();
        focusDelay = setTimeout(function () {
            $searchFormField.focus();
        }, 0);
        $searchForm.addClass('dp-navbar-search-form--isActive');
      }
    }

    function cancelSearch(e) {
      if($searchForm.hasClass('dp-navbar-search-form--isActive')) {
        $searchFormField.val('');
        $searchForm.removeClass('dp-navbar-search-form--isActive');
      }
    }

    $searchSubmitBtn.attr('disabled', false);
    $searchFormField.val('');
    $searchForm.on('submit', toggleSearch);
    $navBar.on('click', cancelSearch);
    $searchCloseBtn.on('click', cancelSearch);


    // prevent mobile safari back button cache
    $(window).on("pageshow", function(event) {
        if (event.originalEvent.persisted) {
            window.location.reload()
        }
    });
});
